#include	<p18cxxx.h>
#include	"APP_EDF11_1_KeyMatrix.h"

void KeyMatrix_Init( void )
{
	TRISGbits.TRISG0 = 1;
	LATGbits.LATG0 = 1;
	TRISGbits.TRISG1 = 1;
	LATGbits.LATG1 = 1;
	TRISGbits.TRISG2 = 1;
	LATGbits.LATG2 = 1;
	TRISGbits.TRISG3 = 1;
	LATGbits.LATG3 = 1;

	TRISEbits.TRISE4 = 1;
	TRISEbits.TRISE5 = 1;
	TRISEbits.TRISE6 = 1;
	TRISEbits.TRISE7 = 1;
}

unsigned int KeyMatrix_KeyStatus( void )
{
	unsigned int KeyStatus = 0;
	unsigned char Temporary = 0;

	TRISGbits.TRISG0 = 0;
	LATGbits.LATG0 = 0;
	TRISGbits.TRISG1 = 1;
	TRISGbits.TRISG2 = 1;
	TRISGbits.TRISG3 = 1;

	//Line1
	Temporary = ( ~( PORTE >> 4 ) ) & 0x0f ;
	TRISGbits.TRISG0 = 1;

	// Button 1
	if( ( Temporary & 0x01 ) == 0x01 )
		KeyStatus |= 0x0001;
	// Button 5
	if( ( Temporary & 0x02 ) == 0x02 )
		KeyStatus |= 0x0010;
	// Button 9
	if( ( Temporary & 0x04 ) == 0x04 )
		KeyStatus |= 0x0100;
	// Button 13
	if( ( Temporary & 0x08 ) == 0x08 )
		KeyStatus |= 0x1000;

	//Line2
	TRISGbits.TRISG1 = 0;
	LATGbits.LATG1 = 0;
	TRISGbits.TRISG0 = 1;
	TRISGbits.TRISG2 = 1;
	TRISGbits.TRISG3 = 1;

	Temporary = ( ~( PORTE >> 4 ) ) & 0x0f ;
	TRISGbits.TRISG1 = 1;

	// Button 2
	if( ( Temporary & 0x01 ) == 0x01 )
		KeyStatus |= 0x0002;
	// Button 6
	if( ( Temporary & 0x02 ) == 0x02 )
		KeyStatus |= 0x0020;
	// Button 10
	if( ( Temporary & 0x04 ) == 0x04 )
		KeyStatus |= 0x0200;
	// Button 14
	if( ( Temporary & 0x08 ) == 0x08 )
		KeyStatus |= 0x2000;

	//Line3
	TRISGbits.TRISG2 = 0;
	LATGbits.LATG2 = 0;
	TRISGbits.TRISG0 = 1;
	TRISGbits.TRISG1 = 1;
	TRISGbits.TRISG3 = 1;

	Temporary = ( ~( PORTE >> 4 ) ) & 0x0f ;
	TRISGbits.TRISG2 = 1;

	// Button 3
	if( ( Temporary & 0x01 ) == 0x01 )
		KeyStatus |= 0x0004;
	// Button 7
	if( ( Temporary & 0x02 ) == 0x02 )
		KeyStatus |= 0x0040;
	// Button 11
	if( ( Temporary & 0x04 ) == 0x04 )
		KeyStatus |= 0x0400;
	// Button 15
	if( ( Temporary & 0x08 ) == 0x08 )
		KeyStatus |= 0x4000;

	//Line4
	TRISGbits.TRISG3 = 0;
	LATGbits.LATG3 = 0;
	TRISGbits.TRISG0 = 1;
	TRISGbits.TRISG1 = 1;
	TRISGbits.TRISG2 = 1;

	Temporary = ( ~( PORTE >> 4 ) ) & 0x0f ;
	TRISGbits.TRISG3 = 1;

	// Button 4
	if( ( Temporary & 0x01 ) == 0x01 )
		KeyStatus |= 0x0008;
	// Button 8
	if( ( Temporary & 0x02 ) == 0x02 )
		KeyStatus |= 0x0080;
	// Button 12
	if( ( Temporary & 0x04 ) == 0x04 )
		KeyStatus |= 0x0800;
	// Button 16
	if( ( Temporary & 0x08 ) == 0x08 )
		KeyStatus |= 0x8000;

	TRISGbits.TRISG0 = 1;
	TRISGbits.TRISG1 = 1;
	TRISGbits.TRISG2 = 1;
	TRISGbits.TRISG3 = 1;

	return KeyStatus;
}