#pragma once
/********************************************************************
 FileName:		Form1.h
 Dependencies:	Windows SDK during development.  When compiled, needs
				.NET framework 3.5 redistributable to run
 Processor:		x86 
 Hardware:		Need a free USB port to connect USB peripheral device
 Compiler:  	Microsoft Visual C++ 2008 Express Edition (or better)
 Company:		Microchip Technology, Inc.

 Software License Agreement:

 The software supplied herewith by Microchip Technology Incorporated
 (the Company? for its PIC?Microcontroller is intended and
 supplied to you, the Company customer, for use solely and
 exclusively with Microchip PIC Microcontroller products. The
 software is owned by the Company and/or its supplier, and is
 protected under applicable copyright laws. All rights are reserved.
 Any use in violation of the foregoing restrictions may subject the
 user to criminal sanctions under applicable laws, as well as to
 civil liability for the breach of the terms and conditions of this
 license.

 THIS SOFTWARE IS PROVIDED IN AN RS IS?CONDITION. NO WARRANTIES,
 WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
 TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT,
 IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
 CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

********************************************************************
 File Description:

 Change History:
  Rev   Date         Description
  1.0   06/11/2009   Initial release

This demonstrates the HID USB DLL interface.

The DLL has four functions:
void USBHIDClassInit (VID, PID, Size) - Sets the Vendor and Product Id used in the class.
                                      Also specifies the Report Size.  This must match
									  the size specified in the devices report descriptor.

bool USBHIDWriteReport (buffer, len)  - Sends a buffer to the device.  len specifies the
                                      number of valid bytes in the buffer.  The data is 
									  padded out to the report size with 0xFF.

bool USBHIDReadReport (buffer)        - Reads a packet from the device and returns it the
                                      buffer.  buffer[0] contains the first byte from the device.

bool IsConnected()                    - Checks with the OS to see if the device is connected
									  (VID & PID specified by USBHIDClassInit).  Returns
									  true if the device has is enumerated.  This is an OS
									  inquiry only and does not generate any traffic on the bus.

ReadReport and WriteReport functions use non-blocking IO calls.  That is the function
will return after one second even if the call fails.  The functions return a boolean indicating 
success or failure.  This allows the application to gracefully recover when the device is 
disconnected rather than hang.

*********************************************************************************************/

namespace GenericHIDDLLSimpleDemo {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace HIDClass;



	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			MCHPHIDClass::USBHIDClassInit (0x4D8, 0x003F, 64);
			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  butToggleLED;
	protected: 

	protected: 


	protected: 



	private: System::Windows::Forms::GroupBox^  groupDeviceState;
	private: System::Windows::Forms::Label^  labDeviceState;



	private: System::Windows::Forms::Timer^  timer1;
	private: System::Windows::Forms::ProgressBar^  ProPotentiometer;


	private: System::Windows::Forms::RadioButton^  ADUpdata;
	private: System::Windows::Forms::Button^  butSendLCMString;
	private: System::Windows::Forms::TextBox^  LCMString1;
	private: System::Windows::Forms::TextBox^  LCMString2;


	private: System::Windows::Forms::GroupBox^  groupButStatus;
	private: System::Windows::Forms::GroupBox^  groupLCDModule;
	private: System::Windows::Forms::RadioButton^  radioBut4;

	private: System::Windows::Forms::RadioButton^  radioBut3;

	private: System::Windows::Forms::RadioButton^  radioBut2;
	private: System::Windows::Forms::RadioButton^  radioBut1;



	private: System::Windows::Forms::RadioButton^  radioBut8;


	private: System::Windows::Forms::RadioButton^  radioBut7;

	private: System::Windows::Forms::RadioButton^  radioBut6;

	private: System::Windows::Forms::RadioButton^  radioBut5;
	private: System::Windows::Forms::RadioButton^  radioBut12;


	private: System::Windows::Forms::RadioButton^  radioBut10;
	private: System::Windows::Forms::RadioButton^  radioBut11;


	private: System::Windows::Forms::RadioButton^  radioBut9;
	private: System::Windows::Forms::RadioButton^  radioBut16;


	private: System::Windows::Forms::RadioButton^  radioBut15;

	private: System::Windows::Forms::RadioButton^  radioBut14;





	private: System::Windows::Forms::GroupBox^  groupTemperature;
	private: System::Windows::Forms::Label^  labTemperature;

	private: System::Windows::Forms::GroupBox^  groupTime;

	internal: System::Windows::Forms::GroupBox^  groupVR;
	private: 




	private: System::Windows::Forms::RadioButton^  radioBut13;
	private: System::Windows::Forms::Label^  labTime;


	private: System::Windows::Forms::Label^  labDate;


	private: System::Windows::Forms::Button^  butTimeSync;
private: System::Windows::Forms::Label^  labDay;


















	private: System::ComponentModel::IContainer^  components;



	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			this->butToggleLED = (gcnew System::Windows::Forms::Button());
			this->groupDeviceState = (gcnew System::Windows::Forms::GroupBox());
			this->labDeviceState = (gcnew System::Windows::Forms::Label());
			this->ADUpdata = (gcnew System::Windows::Forms::RadioButton());
			this->timer1 = (gcnew System::Windows::Forms::Timer(this->components));
			this->ProPotentiometer = (gcnew System::Windows::Forms::ProgressBar());
			this->butSendLCMString = (gcnew System::Windows::Forms::Button());
			this->LCMString1 = (gcnew System::Windows::Forms::TextBox());
			this->LCMString2 = (gcnew System::Windows::Forms::TextBox());
			this->groupButStatus = (gcnew System::Windows::Forms::GroupBox());
			this->radioBut13 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut4 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut3 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut2 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut1 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut8 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut7 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut6 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut5 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut12 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut10 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut11 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut9 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut16 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut15 = (gcnew System::Windows::Forms::RadioButton());
			this->radioBut14 = (gcnew System::Windows::Forms::RadioButton());
			this->groupLCDModule = (gcnew System::Windows::Forms::GroupBox());
			this->groupTemperature = (gcnew System::Windows::Forms::GroupBox());
			this->labTemperature = (gcnew System::Windows::Forms::Label());
			this->groupTime = (gcnew System::Windows::Forms::GroupBox());
			this->labTime = (gcnew System::Windows::Forms::Label());
			this->butTimeSync = (gcnew System::Windows::Forms::Button());
			this->labDay = (gcnew System::Windows::Forms::Label());
			this->labDate = (gcnew System::Windows::Forms::Label());
			this->groupVR = (gcnew System::Windows::Forms::GroupBox());
			this->groupDeviceState->SuspendLayout();
			this->groupButStatus->SuspendLayout();
			this->groupLCDModule->SuspendLayout();
			this->groupTemperature->SuspendLayout();
			this->groupTime->SuspendLayout();
			this->groupVR->SuspendLayout();
			this->SuspendLayout();
			// 
			// butToggleLED
			// 
			this->butToggleLED->Location = System::Drawing::Point(225, 17);
			this->butToggleLED->Name = L"butToggleLED";
			this->butToggleLED->Size = System::Drawing::Size(75, 21);
			this->butToggleLED->TabIndex = 1;
			this->butToggleLED->Text = L"Toggle LED";
			this->butToggleLED->UseVisualStyleBackColor = true;
			this->butToggleLED->Click += gcnew System::EventHandler(this, &Form1::ToggleLED_btn_Click);
			// 
			// groupDeviceState
			// 
			this->groupDeviceState->Controls->Add(this->labDeviceState);
			this->groupDeviceState->Controls->Add(this->ADUpdata);
			this->groupDeviceState->Location = System::Drawing::Point(11, 9);
			this->groupDeviceState->Name = L"groupDeviceState";
			this->groupDeviceState->Size = System::Drawing::Size(208, 29);
			this->groupDeviceState->TabIndex = 4;
			this->groupDeviceState->TabStop = false;
			this->groupDeviceState->Text = L"Device State ";
			// 
			// labDeviceState
			// 
			this->labDeviceState->AutoSize = true;
			this->labDeviceState->Location = System::Drawing::Point(6, 14);
			this->labDeviceState->Name = L"labDeviceState";
			this->labDeviceState->Size = System::Drawing::Size(67, 12);
			this->labDeviceState->TabIndex = 0;
			this->labDeviceState->Text = L"Disconnected";
			// 
			// ADUpdata
			// 
			this->ADUpdata->AutoCheck = false;
			this->ADUpdata->AutoSize = true;
			this->ADUpdata->Location = System::Drawing::Point(188, 12);
			this->ADUpdata->Name = L"ADUpdata";
			this->ADUpdata->Size = System::Drawing::Size(14, 13);
			this->ADUpdata->TabIndex = 6;
			this->ADUpdata->TabStop = true;
			this->ADUpdata->UseVisualStyleBackColor = true;
			this->ADUpdata->CheckedChanged += gcnew System::EventHandler(this, &Form1::ADUpdata_CheckedChanged);
			// 
			// timer1
			// 
			this->timer1->Enabled = true;
			this->timer1->Tick += gcnew System::EventHandler(this, &Form1::timer1_Tick);
			// 
			// ProPotentiometer
			// 
			this->ProPotentiometer->AccessibleRole = System::Windows::Forms::AccessibleRole::None;
			this->ProPotentiometer->Location = System::Drawing::Point(8, 13);
			this->ProPotentiometer->Maximum = 255;
			this->ProPotentiometer->Name = L"ProPotentiometer";
			this->ProPotentiometer->Size = System::Drawing::Size(274, 10);
			this->ProPotentiometer->Step = 1;
			this->ProPotentiometer->Style = System::Windows::Forms::ProgressBarStyle::Continuous;
			this->ProPotentiometer->TabIndex = 5;
			// 
			// butSendLCMString
			// 
			this->butSendLCMString->Location = System::Drawing::Point(16, 76);
			this->butSendLCMString->Name = L"butSendLCMString";
			this->butSendLCMString->Size = System::Drawing::Size(125, 21);
			this->butSendLCMString->TabIndex = 7;
			this->butSendLCMString->Text = L"Send to LCD Module";
			this->butSendLCMString->UseVisualStyleBackColor = true;
			this->butSendLCMString->Click += gcnew System::EventHandler(this, &Form1::butSendLCMString_Click);
			// 
			// LCMString1
			// 
			this->LCMString1->Location = System::Drawing::Point(16, 21);
			this->LCMString1->MaxLength = 16;
			this->LCMString1->Name = L"LCMString1";
			this->LCMString1->Size = System::Drawing::Size(125, 22);
			this->LCMString1->TabIndex = 8;
			// 
			// LCMString2
			// 
			this->LCMString2->Location = System::Drawing::Point(17, 49);
			this->LCMString2->MaxLength = 16;
			this->LCMString2->Name = L"LCMString2";
			this->LCMString2->Size = System::Drawing::Size(124, 22);
			this->LCMString2->TabIndex = 9;
			// 
			// groupButStatus
			// 
			this->groupButStatus->Controls->Add(this->radioBut13);
			this->groupButStatus->Controls->Add(this->radioBut4);
			this->groupButStatus->Controls->Add(this->radioBut3);
			this->groupButStatus->Controls->Add(this->radioBut2);
			this->groupButStatus->Controls->Add(this->radioBut1);
			this->groupButStatus->Controls->Add(this->radioBut8);
			this->groupButStatus->Controls->Add(this->radioBut7);
			this->groupButStatus->Controls->Add(this->radioBut6);
			this->groupButStatus->Controls->Add(this->radioBut5);
			this->groupButStatus->Controls->Add(this->radioBut12);
			this->groupButStatus->Controls->Add(this->radioBut10);
			this->groupButStatus->Controls->Add(this->radioBut11);
			this->groupButStatus->Controls->Add(this->radioBut9);
			this->groupButStatus->Controls->Add(this->radioBut16);
			this->groupButStatus->Controls->Add(this->radioBut15);
			this->groupButStatus->Controls->Add(this->radioBut14);
			this->groupButStatus->Location = System::Drawing::Point(173, 114);
			this->groupButStatus->Name = L"groupButStatus";
			this->groupButStatus->Size = System::Drawing::Size(127, 102);
			this->groupButStatus->TabIndex = 11;
			this->groupButStatus->TabStop = false;
			this->groupButStatus->Text = L"Button:0x0000";
			// 
			// radioBut13
			// 
			this->radioBut13->AutoCheck = false;
			this->radioBut13->AutoSize = true;
			this->radioBut13->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut13->Location = System::Drawing::Point(6, 21);
			this->radioBut13->Name = L"radioBut13";
			this->radioBut13->Size = System::Drawing::Size(14, 13);
			this->radioBut13->TabIndex = 15;
			this->radioBut13->UseVisualStyleBackColor = true;
			// 
			// radioBut4
			// 
			this->radioBut4->AutoCheck = false;
			this->radioBut4->AutoSize = true;
			this->radioBut4->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut4->Location = System::Drawing::Point(105, 84);
			this->radioBut4->Name = L"radioBut4";
			this->radioBut4->Size = System::Drawing::Size(14, 13);
			this->radioBut4->TabIndex = 25;
			this->radioBut4->UseVisualStyleBackColor = true;
			// 
			// radioBut3
			// 
			this->radioBut3->AutoCheck = false;
			this->radioBut3->AutoSize = true;
			this->radioBut3->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut3->Location = System::Drawing::Point(72, 82);
			this->radioBut3->Name = L"radioBut3";
			this->radioBut3->Size = System::Drawing::Size(14, 13);
			this->radioBut3->TabIndex = 24;
			this->radioBut3->UseVisualStyleBackColor = true;
			// 
			// radioBut2
			// 
			this->radioBut2->AutoCheck = false;
			this->radioBut2->AutoSize = true;
			this->radioBut2->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut2->Location = System::Drawing::Point(39, 84);
			this->radioBut2->Name = L"radioBut2";
			this->radioBut2->Size = System::Drawing::Size(14, 13);
			this->radioBut2->TabIndex = 23;
			this->radioBut2->UseVisualStyleBackColor = true;
			// 
			// radioBut1
			// 
			this->radioBut1->AutoCheck = false;
			this->radioBut1->AutoSize = true;
			this->radioBut1->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut1->Location = System::Drawing::Point(6, 84);
			this->radioBut1->Name = L"radioBut1";
			this->radioBut1->Size = System::Drawing::Size(14, 13);
			this->radioBut1->TabIndex = 22;
			this->radioBut1->UseVisualStyleBackColor = true;
			// 
			// radioBut8
			// 
			this->radioBut8->AutoCheck = false;
			this->radioBut8->AutoSize = true;
			this->radioBut8->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut8->Location = System::Drawing::Point(105, 63);
			this->radioBut8->Name = L"radioBut8";
			this->radioBut8->Size = System::Drawing::Size(14, 13);
			this->radioBut8->TabIndex = 21;
			this->radioBut8->UseVisualStyleBackColor = true;
			// 
			// radioBut7
			// 
			this->radioBut7->AutoCheck = false;
			this->radioBut7->AutoSize = true;
			this->radioBut7->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut7->Location = System::Drawing::Point(72, 63);
			this->radioBut7->Name = L"radioBut7";
			this->radioBut7->Size = System::Drawing::Size(14, 13);
			this->radioBut7->TabIndex = 20;
			this->radioBut7->UseVisualStyleBackColor = true;
			// 
			// radioBut6
			// 
			this->radioBut6->AutoCheck = false;
			this->radioBut6->AutoSize = true;
			this->radioBut6->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut6->Location = System::Drawing::Point(39, 61);
			this->radioBut6->Name = L"radioBut6";
			this->radioBut6->Size = System::Drawing::Size(14, 13);
			this->radioBut6->TabIndex = 19;
			this->radioBut6->UseVisualStyleBackColor = true;
			// 
			// radioBut5
			// 
			this->radioBut5->AutoCheck = false;
			this->radioBut5->AutoSize = true;
			this->radioBut5->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut5->Location = System::Drawing::Point(6, 63);
			this->radioBut5->Name = L"radioBut5";
			this->radioBut5->Size = System::Drawing::Size(14, 13);
			this->radioBut5->TabIndex = 18;
			this->radioBut5->UseVisualStyleBackColor = true;
			// 
			// radioBut12
			// 
			this->radioBut12->AutoCheck = false;
			this->radioBut12->AutoSize = true;
			this->radioBut12->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut12->Location = System::Drawing::Point(105, 42);
			this->radioBut12->Name = L"radioBut12";
			this->radioBut12->Size = System::Drawing::Size(14, 13);
			this->radioBut12->TabIndex = 17;
			this->radioBut12->UseVisualStyleBackColor = true;
			// 
			// radioBut10
			// 
			this->radioBut10->AutoCheck = false;
			this->radioBut10->AutoSize = true;
			this->radioBut10->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut10->Location = System::Drawing::Point(39, 42);
			this->radioBut10->Name = L"radioBut10";
			this->radioBut10->Size = System::Drawing::Size(14, 13);
			this->radioBut10->TabIndex = 16;
			this->radioBut10->UseVisualStyleBackColor = true;
			// 
			// radioBut11
			// 
			this->radioBut11->AutoCheck = false;
			this->radioBut11->AutoSize = true;
			this->radioBut11->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut11->Location = System::Drawing::Point(72, 42);
			this->radioBut11->Name = L"radioBut11";
			this->radioBut11->Size = System::Drawing::Size(14, 13);
			this->radioBut11->TabIndex = 15;
			this->radioBut11->UseVisualStyleBackColor = true;
			// 
			// radioBut9
			// 
			this->radioBut9->AutoCheck = false;
			this->radioBut9->AutoSize = true;
			this->radioBut9->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut9->Location = System::Drawing::Point(6, 42);
			this->radioBut9->Name = L"radioBut9";
			this->radioBut9->Size = System::Drawing::Size(14, 13);
			this->radioBut9->TabIndex = 14;
			this->radioBut9->UseVisualStyleBackColor = true;
			// 
			// radioBut16
			// 
			this->radioBut16->AutoCheck = false;
			this->radioBut16->AutoSize = true;
			this->radioBut16->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut16->Location = System::Drawing::Point(105, 21);
			this->radioBut16->Name = L"radioBut16";
			this->radioBut16->Size = System::Drawing::Size(14, 13);
			this->radioBut16->TabIndex = 13;
			this->radioBut16->UseVisualStyleBackColor = true;
			// 
			// radioBut15
			// 
			this->radioBut15->AutoCheck = false;
			this->radioBut15->AutoSize = true;
			this->radioBut15->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut15->Location = System::Drawing::Point(72, 21);
			this->radioBut15->Name = L"radioBut15";
			this->radioBut15->Size = System::Drawing::Size(14, 13);
			this->radioBut15->TabIndex = 12;
			this->radioBut15->UseVisualStyleBackColor = true;
			// 
			// radioBut14
			// 
			this->radioBut14->AutoCheck = false;
			this->radioBut14->AutoSize = true;
			this->radioBut14->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			this->radioBut14->Location = System::Drawing::Point(39, 21);
			this->radioBut14->Name = L"radioBut14";
			this->radioBut14->Size = System::Drawing::Size(14, 13);
			this->radioBut14->TabIndex = 11;
			this->radioBut14->UseVisualStyleBackColor = true;
			// 
			// groupLCDModule
			// 
			this->groupLCDModule->Controls->Add(this->LCMString1);
			this->groupLCDModule->Controls->Add(this->butSendLCMString);
			this->groupLCDModule->Controls->Add(this->LCMString2);
			this->groupLCDModule->Location = System::Drawing::Point(11, 114);
			this->groupLCDModule->Name = L"groupLCDModule";
			this->groupLCDModule->Size = System::Drawing::Size(156, 102);
			this->groupLCDModule->TabIndex = 12;
			this->groupLCDModule->TabStop = false;
			this->groupLCDModule->Text = L"LCD Module";
			// 
			// groupTemperature
			// 
			this->groupTemperature->Controls->Add(this->labTemperature);
			this->groupTemperature->Location = System::Drawing::Point(12, 44);
			this->groupTemperature->Name = L"groupTemperature";
			this->groupTemperature->Size = System::Drawing::Size(81, 29);
			this->groupTemperature->TabIndex = 5;
			this->groupTemperature->TabStop = false;
			this->groupTemperature->Text = L"Temperature";
			// 
			// labTemperature
			// 
			this->labTemperature->AutoSize = true;
			this->labTemperature->Location = System::Drawing::Point(21, 14);
			this->labTemperature->Name = L"labTemperature";
			this->labTemperature->Size = System::Drawing::Size(51, 12);
			this->labTemperature->TabIndex = 0;
			this->labTemperature->Text = L"Unknown";
			// 
			// groupTime
			// 
			this->groupTime->Controls->Add(this->labTime);
			this->groupTime->Controls->Add(this->butTimeSync);
			this->groupTime->Controls->Add(this->labDay);
			this->groupTime->Controls->Add(this->labDate);
			this->groupTime->Location = System::Drawing::Point(99, 44);
			this->groupTime->Name = L"groupTime";
			this->groupTime->Size = System::Drawing::Size(201, 29);
			this->groupTime->TabIndex = 6;
			this->groupTime->TabStop = false;
			this->groupTime->Text = L"Time";
			// 
			// labTime
			// 
			this->labTime->AutoSize = true;
			this->labTime->Location = System::Drawing::Point(63, 14);
			this->labTime->Name = L"labTime";
			this->labTime->Size = System::Drawing::Size(47, 12);
			this->labTime->TabIndex = 13;
			this->labTime->Text = L"00:00:00";
			// 
			// butTimeSync
			// 
			this->butTimeSync->Location = System::Drawing::Point(157, 8);
			this->butTimeSync->Name = L"butTimeSync";
			this->butTimeSync->Size = System::Drawing::Size(44, 21);
			this->butTimeSync->TabIndex = 15;
			this->butTimeSync->Text = L"Sync";
			this->butTimeSync->UseVisualStyleBackColor = true;
			this->butTimeSync->Click += gcnew System::EventHandler(this, &Form1::butTimeSync_Click);
			// 
			// labDay
			// 
			this->labDay->AutoSize = true;
			this->labDay->Location = System::Drawing::Point(111, 14);
			this->labDay->Name = L"labDay";
			this->labDay->Size = System::Drawing::Size(26, 12);
			this->labDay->TabIndex = 16;
			this->labDay->Text = L"Sun.";
			// 
			// labDate
			// 
			this->labDate->AutoSize = true;
			this->labDate->Location = System::Drawing::Point(7, 14);
			this->labDate->Name = L"labDate";
			this->labDate->Size = System::Drawing::Size(59, 12);
			this->labDate->TabIndex = 14;
			this->labDate->Text = L"2000/00/00";
			// 
			// groupVR
			// 
			this->groupVR->Controls->Add(this->ProPotentiometer);
			this->groupVR->Location = System::Drawing::Point(12, 79);
			this->groupVR->Name = L"groupVR";
			this->groupVR->Size = System::Drawing::Size(288, 29);
			this->groupVR->TabIndex = 6;
			this->groupVR->TabStop = false;
			this->groupVR->Text = L"Potentiometer";
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(309, 225);
			this->Controls->Add(this->groupVR);
			this->Controls->Add(this->groupTime);
			this->Controls->Add(this->groupTemperature);
			this->Controls->Add(this->groupLCDModule);
			this->Controls->Add(this->butToggleLED);
			this->Controls->Add(this->groupButStatus);
			this->Controls->Add(this->groupDeviceState);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"Form1";
			this->Text = L"Generic HID DLL Muti Application Demo";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->groupDeviceState->ResumeLayout(false);
			this->groupDeviceState->PerformLayout();
			this->groupButStatus->ResumeLayout(false);
			this->groupButStatus->PerformLayout();
			this->groupLCDModule->ResumeLayout(false);
			this->groupLCDModule->PerformLayout();
			this->groupTemperature->ResumeLayout(false);
			this->groupTemperature->PerformLayout();
			this->groupTime->ResumeLayout(false);
			this->groupTime->PerformLayout();
			this->groupVR->ResumeLayout(false);
			this->ResumeLayout(false);

		}
#pragma endregion

private: System::Void timer1_Tick(System::Object^  sender, System::EventArgs^  e) {
		 unsigned char OutputPacketBuffer[64];	//Allocate a memory buffer equal to our report size
		 unsigned char InputPacketBuffer[64];	//Allocate a memory buffer equal to our report size	

		 unsigned int Temporary;
		 float Temperature;

		 ProPotentiometer->Maximum = 1023;

		 if (MCHPHIDClass::USBHIDWriteReport (OutputPacketBuffer, 1) == true)
		 {
			 labDeviceState->Text = "Connected";	
			 
			if( MCHPHIDClass::USBHIDReadReport (InputPacketBuffer) == true )
			{
				if(InputPacketBuffer[0] == 0x37)	
				 {
					Temporary= InputPacketBuffer[2] * 256 + InputPacketBuffer[1]; 
				
					if( Temporary > 1023 )
						Temporary = 1023;
				
					ProPotentiometer->Value = 1023 - Temporary;
					ADUpdata->Checked= ! ADUpdata->Checked;

				    radioBut1->Checked = ( InputPacketBuffer[ 3 ] & 0x01 ) == 0x01; 
				    radioBut2->Checked = ( InputPacketBuffer[ 3 ] & 0x02 ) == 0x02; 
				    radioBut3->Checked = ( InputPacketBuffer[ 3 ] & 0x04 ) == 0x04; 
				    radioBut4->Checked = ( InputPacketBuffer[ 3 ] & 0x08 ) == 0x08; 
				    radioBut5->Checked = ( InputPacketBuffer[ 3 ] & 0x10 ) == 0x10; 
				    radioBut6->Checked = ( InputPacketBuffer[ 3 ] & 0x20 ) == 0x20; 
				    radioBut7->Checked = ( InputPacketBuffer[ 3 ] & 0x40 ) == 0x40; 
				    radioBut8->Checked = ( InputPacketBuffer[ 3 ] & 0x80 ) == 0x80; 
				
				    radioBut9->Checked = ( InputPacketBuffer[ 4 ] & 0x01 ) == 0x01; 
				    radioBut10->Checked = ( InputPacketBuffer[ 4 ] & 0x02 ) == 0x02; 
				    radioBut11->Checked = ( InputPacketBuffer[ 4 ] & 0x04 ) == 0x04; 
				    radioBut12->Checked = ( InputPacketBuffer[ 4 ] & 0x08 ) == 0x08; 
				    radioBut13->Checked = ( InputPacketBuffer[ 4 ] & 0x10 ) == 0x10; 
				    radioBut14->Checked = ( InputPacketBuffer[ 4 ] & 0x20 ) == 0x20; 
				    radioBut15->Checked = ( InputPacketBuffer[ 4 ] & 0x40 ) == 0x40; 
				    radioBut16->Checked = ( InputPacketBuffer[ 4 ] & 0x80 ) ==0x80; 

					groupButStatus->Text= "Button:0x" + String::Format("{0:x2}",InputPacketBuffer[4]) + String::Format("{0:x2}",InputPacketBuffer[3]);

					Temperature = ( float ) InputPacketBuffer[6] / 256;
					Temperature += 	InputPacketBuffer[5];
					labTemperature->Text = String::Format("{0:f4}",Temperature ) + "XC";

					labTime->Text = String::Format("{0:x2}",InputPacketBuffer[ 9 ] ) + ":" + String::Format("{0:x2}",InputPacketBuffer[ 8 ] ) + ":" + String::Format("{0:x2}",InputPacketBuffer[ 7 ]) ;
					labDate->Text = "20" + String::Format("{0:x2}",InputPacketBuffer[ 12 ] ) + "/" + String::Format("{0:x2}",InputPacketBuffer[ 11 ] ) + "/" + String::Format("{0:x2}",InputPacketBuffer[ 10 ]) ;
				
					switch( InputPacketBuffer[ 13 ] )
					{
					case 1:
						labDay->Text = "Mon.";
						break;
					case 2:
						labDay->Text = "Tues.";
						break;
					case 3:
						labDay->Text = "Wed.";
						break;
					case 4:
						labDay->Text = "Thur.";
						break;
					case 5:
						labDay->Text = "Fri.";
						break;
					case 6:
						labDay->Text = "Sat.";
						break;
					default:
						labDay->Text = "Sun.";
						break;
					}
				}
			}
		}
		 else
		 {
			 labDeviceState->Text = "Disconnected";	
		 }

		 }
private: System::Void ToggleLED_btn_Click(System::Object^  sender, System::EventArgs^  e) {
		 unsigned char OutputPacketBuffer[64];	//Allocate a memory buffer equal to our report size

		 OutputPacketBuffer[0] = 0x80;		//0x80 is the "Toggle LED(s)" command in the firmware
		 if (MCHPHIDClass::USBHIDWriteReport (OutputPacketBuffer, 1) == true)
		 {
			 labDeviceState->Text = "Connected";
		 }
		 else
		 {
			 labDeviceState->Text = "Disconnected";	
		 }
		 }


private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {
		 }
private: System::Void ADUpdata_CheckedChanged(System::Object^  sender, System::EventArgs^  e) {
		 }
private: System::Void butSendLCMString_Click(System::Object^  sender, System::EventArgs^  e) {

	unsigned char OutputPacketBuffer[64];	//Allocate a memory buffer equal to our report size

	unsigned char i;

	for( i = 0 ; i < 64 ; i ++ )
		OutputPacketBuffer[ i ] = ' ';

	OutputPacketBuffer[0] = 0x90;
	
	for( i = 0 ; i < LCMString1->Text->Length ; i ++ )
		OutputPacketBuffer[ i + 1 ] =  ( unsigned char ) LCMString1->Text[i];

	for( i = 0 ; i < LCMString2->Text->Length ; i ++ )
		OutputPacketBuffer[ i + 17 ] = ( unsigned char ) LCMString2->Text[i];

	

	if (MCHPHIDClass::USBHIDWriteReport (OutputPacketBuffer,64) == true)
	{
		labDeviceState->Text = "Connected";
	}

	else
	{
		labDeviceState->Text = "Disconnected";	
	}

	}
private: System::Void butTimeSync_Click(System::Object^  sender, System::EventArgs^  e) {

	unsigned char OutputPacketBuffer[64];	//Allocate a memory buffer equal to our report size

	unsigned char i;
	unsigned char Temporary;

	DateTime NowDateTime = DateTime::Now;

	for( i = 0 ; i < 64 ; i ++ )
		OutputPacketBuffer[ i ] = ' ';

	OutputPacketBuffer[0] = 0xA0;
	
	Temporary = NowDateTime.Second % 10;
	Temporary |= ( unsigned char )( NowDateTime.Second / 10 ) << 4;
	OutputPacketBuffer[1] =  Temporary;

	Temporary = NowDateTime.Minute % 10;
	Temporary |= ( unsigned char )( NowDateTime.Minute / 10 ) << 4;
	OutputPacketBuffer[2] =  Temporary;

	Temporary = NowDateTime.Hour % 10;
	Temporary |= ( unsigned char )( NowDateTime.Hour / 10 ) << 4;
	OutputPacketBuffer[3] =  Temporary;
	
	Temporary = NowDateTime.Day % 10;
	Temporary |= ( unsigned char )( NowDateTime.Day / 10 ) << 4;
	OutputPacketBuffer[4] =  Temporary;

	Temporary = NowDateTime.Month % 10;
	Temporary |= ( unsigned char )( NowDateTime.Month / 10 ) << 4;
	OutputPacketBuffer[5] =  Temporary;

	Temporary = NowDateTime.Year % 10;
	Temporary |= ( unsigned char )( NowDateTime.Year / 10 ) << 4;
	OutputPacketBuffer[6] =  Temporary;

	Temporary = ( unsigned char ) NowDateTime.DayOfWeek;
	OutputPacketBuffer[7] =  Temporary;

	if (MCHPHIDClass::USBHIDWriteReport (OutputPacketBuffer,64) == true)
	{
		labDeviceState->Text = "Connected";
	}

	else
	{
		labDeviceState->Text = "Disconnected";	
	}

	}
};
}
